#define PORTNUM         0xFCE          // Port number

SOCKET ServerSock = INVALID_SOCKET;   // Socket bound to the server

int NetworkConnect(char *Server)
{
  SOCKADDR_IN local_sin,accept_sin;
  SOCKADDR_IN destination_sin;        // Server socket address
  PHOSTENT phostent = NULL;           // Points to the HOSTENT structure
                                      // of the server
  WSADATA WSAData;                    // Contains details of the 
                                      // Winsocket implementation

  // Initialize Winsocket.
 if (WSAStartup (MAKEWORD(1,1), &WSAData) != 0) 
 {
   return -1;
 }

 if(Server)
 {
  // Create a TCP/IP socket that is bound to the server.
  if ((ServerSock = socket (AF_INET, SOCK_STREAM, 0)) == INVALID_SOCKET)
    return -1;

  // Fill out the server socket's address information.
  destination_sin.sin_family = AF_INET;

  // Retrieve the host information corresponding to the host name.
  if ((phostent = gethostbyname (Server)) == NULL) 
  {
    closesocket (ServerSock);
    return -1;
  }

  memcpy ((char FAR *)&(destination_sin.sin_addr), 
          phostent->h_addr, 
          phostent->h_length);
  destination_sin.sin_port = htons (PORTNUM);      
  if (connect (ServerSock, 
               (PSOCKADDR) &destination_sin, 
               sizeof (destination_sin)) == SOCKET_ERROR) 
  {
    closesocket (ServerSock);
    return -1;
  }
 }
 else
 {
  SOCKET WinSock=INVALID_SOCKET;

  int accept_sin_len;

  if ((WinSock = socket (AF_INET, SOCK_STREAM, 0)) == INVALID_SOCKET)
    return 0;
  local_sin.sin_family=AF_INET;
  local_sin.sin_port=htons(PORTNUM);
  local_sin.sin_addr.s_addr=htonl(INADDR_ANY);
  if(bind(WinSock,(struct sockaddr *)&local_sin,sizeof(local_sin))==SOCKET_ERROR)
   {closesocket(ServerSock);return 0;}

  if(listen(WinSock,1)==SOCKET_ERROR)
   {closesocket(WinSock);return 0;}

  accept_sin_len=sizeof(accept_sin);

  ServerSock=accept(WinSock,(struct sockaddr*) &accept_sin,(int *)&accept_sin_len);
  closesocket(WinSock);
  if(ServerSock==INVALID_SOCKET)
   return -1; 
 }

 {
  unsigned long t;
  t=1;
  if(ioctlsocket(ServerSock,FIONBIO,&t))
  {
   printf("Error setting socket to non-blocking mode!\n");
   return 0;
  }
 }
  return 1;
}


void NetworkClose(void)
{
  // Disable sending on ServerSock.
  shutdown (ServerSock, 0x01);

  // Disable receiving on ServerSock.
  shutdown (ServerSock, 0x00);

  // Close the socket.
  closesocket (ServerSock);

  WSACleanup ();
}


int NetworkSendByte(unsigned char *Value)
{
  for(;;)
  {
   if(send(ServerSock,Value,1,0)==SOCKET_ERROR)
    {
      switch(WSAGetLastError())
      {
      default:
       return 0;
      case WSAEWOULDBLOCK: if(BlockingCheck()) return 0; continue;
      }
    }
    else
     break;
  }
return 1;
}

int NetworkRecvByte(unsigned char *Value)
{
  for(;;)
  {
   if(recv(ServerSock,Value,1,0)==SOCKET_ERROR)
    {
      switch(WSAGetLastError())
      {
      default:
       return 0;
      case WSAEWOULDBLOCK: if(BlockingCheck()) return 0; continue;
      }
    }
    else
     break;
  }
return 1;
}

